/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/
/** @file
 * @brief fstream which creates files with mkstemp.
 *
 * @author Gerd v. Egidy
 *
 * @copyright &copy; Copyright 2010 by Intra2net AG
 */

#include <string>
#include <fstream>
#include <sstream>
#include <iostream>

#include "tmpfstream.hpp"
#include "tmpfstream_impl.hpp"

using namespace std;

namespace I2n
{

template< typename Device, typename Tr, typename Alloc >
const std::string tmpfcopystreamTempl<Device, Tr, Alloc>
    ::default_template_suffix=".tmp.XXXXXX";

// explicitly instantiate the most used versions.
// means they get compiled into the lib and you don't need tmpfstream_impl.hpp
// if you want to use anything else, include tmpfstream_impl.hpp.
template class tmpfstreamTempl<bio::file_descriptor_sink>;
template class tmpfstreamTempl<bio::file_descriptor>;

template class tmpfcopystreamTempl<bio::file_descriptor_sink>;
template class tmpfcopystreamTempl<bio::file_descriptor>;

}
